#pragma once
#include "afxwin.h"
#include "afxcmn.h"
#include "GdiPlusWrapper.h"
#include "ProfileDlg.h"
#include "ChatDlg.h"
#include "Global.h"
#include <afxole.h>
#include "ListCtrlOrg.h"
#include "GdiPlusWrapper.h"
#include "NMImgButton.h"

#define WM_USER_RESULT_MENU		(WM_USER +1000)	
#define WM_USER_FAVORITE_ADD	(WM_USER +2000)	
// CSearchDlg ȭ Դϴ.



class CSearchDlg : public CSkinDialog, IGTWASActorEvent ,IGTMessengerActorEvent
{
	DECLARE_DYNAMIC(CSearchDlg)
	

public:
	BOOL Create(LPCTSTR pszSearchText, LPCTSTR pszCondition, UINT nIDTemplate, CWnd* pParentWnd= NULL);
public:
	CSearchDlg(CWnd* pParent = NULL);   // ǥ Դϴ.
	CSearchDlg(LPCTSTR pszSearchText, LPCTSTR pszCondition, CWnd* pParent = NULL);
	virtual ~CSearchDlg();

// ȭ  Դϴ.
	enum { IDD = IDD_SEARCH_DIALOG };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV Դϴ.

	DECLARE_MESSAGE_MAP()

	virtual BOOL OnInitDialog();
public:
	CImageList *m_pImageList;
	virtual BOOL PreTranslateMessage(MSG* pMsg);

	CEdit m_edSeachText;
	CNMImgComboBox m_cmbSearchCondition;
	CNMImgButton m_btnSearch;
	CNMImgButton m_btnFavoriteAdd;
	CNMImgButton m_btnIMInvite;
	CNMImgButton m_btnRecipentAdd;
	CListCtrlOrg m_lcResult;
	CRect m_rcImage;

	COleDataSource _oleDataSource; 	
	void InitList(CListCtrlOrg &list, const TCHAR**pszTitle);
	void ResizeListColumn(CListCtrlOrg &list, const int *arrWidth);


	void __ResourceLoad(BOOL bInit = FALSE);

	afx_msg void OnBnClickedButtonSearch();
	afx_msg void OnBnClickedButtonFavoriteAdd();
	afx_msg void OnBnClickedButtonImInvite();
	afx_msg void OnBnClickedButtonRecipentAdd();
	afx_msg void OnNMClickListSearchResult(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnNMRClickListSearchResult(NMHDR *pNMHDR, LRESULT *pResult);
//	afx_msg LRESULT OnNcHitTest(CPoint point);
	CChatDlg* m_pChatDlg; 
	virtual bool OnGTMessengerActor_UpdateNotBuddyUserStatus(IGTMessengerActor *pActor, LPCWSTR strBuddyID, int nUserStatus);
	void CSearchDlg::SetCharDlgPtr(CChatDlg* pDlg);

	CString m_strInitSearchText;
	CString m_strInitCondition;
	UINT _clipBoardFormat;

private:
	CString m_strSearchText;
	CString m_strCondition;

	GROUP_MEMU_LIST m_GroupList;

public:
	afx_msg void OnBnClickedCloseButton();
	afx_msg void OnBnClickedMaxButton();
	afx_msg void OnBnClickedMinButton();


public:
	virtual bool OnGTWASActor_ResponseNameSearchList(IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode eErrorCode, const NE_MEMBER_DATA_LIST &list);


	afx_msg void OnMnProfile();
	afx_msg void OnMnIMInvite();
	afx_msg void OnMnSendMemo();
	void OnMenuResultListFavoriteAdd(WPARAM wParam);
	void OnMenuListFavoriteAdd(WPARAM wParam);
	BOOL AddFavoriteList(std::vector<wstring> &vecBuddyId, int nGroupID);
	afx_msg void OnDestroy();
	
	void ResizeCtrl(void);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnPaint();
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnNcLButtonUp(UINT nHitTest, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnLvnBeginrdragListSearchResult(NMHDR *pNMHDR, LRESULT *pResult);
};
